/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is openCRX.
 *
 * The Initial Developer of the Original Code is
 * Josh Geenen <opencrx@pirules.net>.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var oExport = {
  begin: function oExport_begin(aAb) {
    if (oAbManager.mVersion < 3) {
      alert(oStringBundle.getStr("versionErr"));
      return false;
    }
    oLOGGER.LOG("***Starting export from the address book named: " +
                aAb.getName() + " at: " + (new Date()).toLocaleTimeString());
    // get the address book and all of its contacts
    var ab = aAb;
    var cards = ab.getAllCards();
    // convert the contacts to a string of vCards
    var str = "";
    for (var i = 0; i < cards.length; i++) {
      oOverlay.setStatusBarText("Converting contacts to vCards: " + (i + 1) +
                                " of " + cards.length);
      str += oContactConverter.contactToVCard(cards[i]);
    }
    // create and send the HTTP request
    oOverlay.setStatusBarText("Sending exported contacts");
    oLOGGER.VERBOSE_LOG(str);
    var req = new oHttpRequest();
    req.mUrl = ab.getUrl();
    req.mContentType = "text/x-vcard";
    req.mType = "PUT";
    req.mBody = str;
    //req.mType = "POST";
    //req.addContentOverride("PUT");
    req.mOnSuccess = ["oLOGGER.LOG('***Finished export from the address book " +
                      "named: " + aAb.getName() + " at: ' + " +
                      "(new Date()).toLocaleTimeString()); oOverlay." + 
                      "setStatusBarText('Finished export successfully');"];
    req.mOnError = ["alert('ERROR' + httpReq.responseText);"];
    req.send();
  }
};
